/*

  Copyright (C) 2000, 2001 Silicon Graphics, Inc.  All Rights Reserved.

  This program is free software; you can redistribute it and/or modify it
  under the terms of version 2 of the GNU General Public License as
  published by the Free Software Foundation.

  This program is distributed in the hope that it would be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

  Further, this software is distributed without any warranty that it is
  free of the rightful claim of any third person regarding infringement 
  or the like.  Any license provided herein, whether implied or 
  otherwise, applies only to this software file.  Patent licenses, if 
  any, provided herein do not apply to combinations of this program with 
  other software, or any other product whatsoever.  

  You should have received a copy of the GNU General Public License along
  with this program; if not, write the Free Software Foundation, Inc., 59
  Temple Place - Suite 330, Boston MA 02111-1307, USA.

  Contact information:  Silicon Graphics, Inc., 1600 Amphitheatre Pky,
  Mountain View, CA 94043, or:

  http://www.sgi.com

  For further information regarding this notice, see:

  http://oss.sgi.com/projects/GenInfo/NoticeExplan

*/

#include "intrn_info.h"

// eraxxon: see comments about 'const' in intrn_info.h

/*const*/
intrn_info_t intrn_info[INTRINSIC_LAST+1] = {
  { /* NONE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "__powii"},
  { /* I8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, NULL, "__powll"},
  { /* F4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, NULL, "powf"},
  { /* F8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, NULL, "pow"},
  { /* FQEXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, NULL, "qpow"},
  { /* C4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, NULL, "__powcc"},
  { /* C8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, NULL, "__powzz"},
  { /* CQEXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, NULL, "__cqpow"},
  { /* F4I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, NULL, "__powri"},
  { /* F4I8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, NULL, "__powrl"},
  { /* F8I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, NULL, "__powdi"},
  { /* F8I8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, NULL, "__powdl"},
  { /* FQI4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, NULL, "__pow_qi"},
  { /* FQI8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, NULL, "__pow_ql"},
  { /* C4I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, NULL, "__powci"},
  { /* C4I8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, NULL, "__powcl"},
  { /* C8I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, NULL, "__powzi"},
  { /* C8I8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, NULL, "__powzl"},
  { /* CQI4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, NULL, "__powcqi"},
  { /* CQI8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, NULL, "__powcql"},
  { /* CEQEXPR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "s_cmp"},
  { /* CNEEXPR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "s_cmp"},
  { /* CGEEXPR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "s_cmp"},
  { /* CGTEXPR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "s_cmp"},
  { /* CLEEXPR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "s_cmp"},
  { /* CLTEXPR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "s_cmp"},
  { /* SUBSTRINGEXPR */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, NULL, "s_copy"},
  { /* CONCATEXPR */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, NULL, "s_cat"},
  { /* CASSIGNSTMT */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, NULL, "s_copy"},
  { /* I2ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIABS", "h_abs"},
  { /* I4ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIABS", "i_abs"},
  { /* I8ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIABS", "l_abs"},
  { /* F4ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ABS", "r_abs"},
  { /* F8ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DABS", "d_abs"},
  { /* FQABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QABS", "__q_abs"},
  { /* F4C4ABS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "CABS", "__c8abs"},
  { /* F4C4ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "CABS", "c_abs_"},
  { /* F8C8ABS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "ZABS", "__zabs"},
  { /* F8C8ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "ZABS", "z_abs_"},
  { /* FQCQABS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "CQABS", "__cqabs"},
  { /* FQCQABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "CQABS", "__cq_abs"},
  { /* I2MODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IMOD", "h_mod"},
  { /* I4MODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JMOD", "i_mod"},
  { /* I8MODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KMOD", "l_mod"},
  { /* F4MOD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "AMOD", "__rmod"},
  { /* F4MODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "AMOD", "r_mod"},
  { /* F8MOD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DMOD", "__dmod"},
  { /* F8MODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DMOD", "d_mod"},
  { /* FQMOD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QMOD", "__qmod"},
  { /* FQMODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QMOD", "__q_mod"},
  { /* F4SQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SQRT", "r_sqrt"},
  { /* F8SQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSQRT", "d_sqrt"},
  { /* FQSQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSQRT", "__q_sqrt"},
  { /* C4SQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CSQRT", "c_sqrt_"},
  { /* C8SQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZSQRT", "z_sqrt_"},
  { /* CQSQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQSQRT", "__cq_sqrt"},
  { /* C4CONJG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CONJG", "__rconjg"},
  { /* C4CONJGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CONJG", "r_cnjg_"},
  { /* C8CONJG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "DCONJG", "__dconjg"},
  { /* C8CONJGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "DCONJG", "d_cnjg_"},
  { /* CQCONJG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "QCONJG", "__qconjg"},
  { /* CQCONJGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "QCONJG", "__cq_conjg"},
  { /* I1DIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "DIM", "b_dim"},
  { /* I2DIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIDIM", "h_dim"},
  { /* I2DIMe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIDIM", "h_dim"},
  { /* I4DIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIDIM", "i_dim"},
  { /* I4DIMe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIDIM", "i_dim"},
  { /* I8DIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIDIM", "l_dim"},
  { /* I8DIMe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIDIM", "l_dim"},
  { /* F4DIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "DIM", "r_dim"},
  { /* F4DIMe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "DIM", "r_dim"},
  { /* F8DIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DDIM", "d_dim"},
  { /* F8DIMe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DDIM", "d_dim"},
  { /* FQDIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QDIM", "__qdim"},
  { /* FQDIMe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QDIM", "__qdim"},
  { /* F8F4PROD */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DPROD", "d_prod"},
  { /* F8F4PRODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DPROD", "d_prod"},
  { /* FQF8PROD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QPROD", "__qprod"},
  { /* FQF8PRODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QPROD", "__q_prod"},
  { /* I1SIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "SIGN", "__bsign"},
  { /* I2SIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IISIGN", "__hsign"},
  { /* I2SIGNe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IISIGN", "h_sign"},
  { /* I4SIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JISIGN", "__isign"},
  { /* I4SIGNe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JISIGN", "i_sign"},
  { /* I8SIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KISIGN", "__lsign"},
  { /* I8SIGNe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KISIGN", "l_sign"},
  { /* F4SIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SIGN", "__rsign"},
  { /* F4SIGNe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SIGN", "r_sign"},
  { /* F8SIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSIGN", "__dsign"},
  { /* F8SIGNe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSIGN", "d_sign"},
  { /* FQSIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSIGN", "__qsign"},
  { /* FQSIGNe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSIGN", "__q_sign"},
  { /* F4IMAGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "IMAG", "r_imag"},
  { /* F8IMAGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DIMAG", "d_imag"},
  { /* FQIMAGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QIMAG", "__cq_imag"},
  { /* F4AINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "AINT", "truncf"},
  { /* F4AINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "AINT", "r_int"},
  { /* F8AINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DINT", "trunc"},
  { /* F8AINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DINT", "d_int"},
  { /* FQAINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QINT", "__qint"},
  { /* FQAINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QINT", "__q_int"},
  { /* I2F4INTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IINT", "__iirint"},
  { /* I4F4INTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JINT", "__jirint"},
  { /* I8F4INTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KINT", "__kirint"},
  { /* I2F8IDINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIDINT", "__iidint"},
  { /* I4F8IDINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIDINT", "__jidint"},
  { /* I8F8IDINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIDINT", "__kidint"},
  { /* I2FQIQINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIQINT", "__iiqint"},
  { /* I4FQIQINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIQINT", "__jiqint"},
  { /* I8FQIQINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIQINT", "__kiqint"},
  { /* I2F4NINT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "ININT", "h_nint"},
  { /* I2F4NINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "ININT", "h_nint"},
  { /* I4F4NINT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JNINT", "i_nint"},
  { /* I4F4NINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JNINT", "i_nint"},
  { /* I8F4NINT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KNINT", "l_nint"},
  { /* I8F4NINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KNINT", "l_nint"},
  { /* I2F8IDNINT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIDNNT", "h_dnnt"},
  { /* I2F8IDNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIDNNT", "h_dnnt"},
  { /* I4F8IDNINT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIDNNT", "i_dnnt"},
  { /* I4F8IDNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIDNNT", "i_dnnt"},
  { /* I8F8IDNINT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIDNNT", "l_dnnt"},
  { /* I8F8IDNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIDNNT", "l_dnnt"},
  { /* I2FQIQNINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIQNNT", "__iiqnnt"},
  { /* I2FQIQNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIQNNT", "__ii_qnnt"},
  { /* I4FQIQNINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIQNNT", "__jiqnnt"},
  { /* I4FQIQNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIQNNT", "__ji_qnnt"},
  { /* I8FQIQNINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIQNNT", "__kiqnnt"},
  { /* I8FQIQNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIQNNT", "__ki_qnnt"},
  { /* F4ANINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ANINT", "__rnint"},
  { /* F4ANINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ANINT", "r_nint"},
  { /* F8ANINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DNINT", "__dnint"},
  { /* F8ANINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DNINT", "d_nint"},
  { /* FQANINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QNINT", "__qnint"},
  { /* FQANINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QNINT", "__q_nint"},
  { /* I2BNOTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "INOT", "not_h"},
  { /* I4BNOTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JNOT", "not_l"},
  { /* I8BNOTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KNOT", "not_ll"},
  { /* I2BANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIAND", "and_h"},
  { /* I4BANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIAND", "and_l"},
  { /* I8BANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIAND", "and_ll"},
  { /* I2BIORe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIOR", "or_h"},
  { /* I4BIORe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIOR", "or_l"},
  { /* I8BIORe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIOR", "or_ll"},
  { /* I2BXORe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIEOR", "xor_h"},
  { /* I4BXORe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIEOR", "xor_l"},
  { /* I8BXORe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIEOR", "xor_ll"},
  { /* I1BITS */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "IBITS", "bext_b"},
  { /* I2BITS */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIBITS", "bext_h"},
  { /* I2BITSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIBITS", "bext_h"},
  { /* I4BITS */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIBITS", "bext_l"},
  { /* I4BITSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIBITS", "bext_l"},
  { /* I8BITS */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIBITS", "bext_ll"},
  { /* I8BITSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIBITS", "bext_ll"},
  { /* I1BSET */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "IBSET", "bset_b"},
  { /* I2BSET */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIBSET", "bset_h"},
  { /* I2BSETe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIBSET", "bset_h"},
  { /* I4BSET */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIBSET", "bset_l"},
  { /* I4BSETe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIBSET", "bset_l"},
  { /* I8BSET */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIBSET", "bset_ll"},
  { /* I8BSETe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIBSET", "bset_ll"},
  { /* I1BCLR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "IBCLR", "bclr_b"},
  { /* I2BCLR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIBCLR", "bclr_h"},
  { /* I2BCLRe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIBCLR", "bclr_h"},
  { /* I4BCLR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIBCLR", "bclr_l"},
  { /* I4BCLRe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIBCLR", "bclr_l"},
  { /* I8BCLR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIBCLR", "bclr_ll"},
  { /* I8BCLRe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIBCLR", "bclr_ll"},
  { /* I1BTEST */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "BTEST", "btest_b"},
  { /* I2BTEST */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "BITEST", "btest_h"},
  { /* I2BTESTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "BITEST", "btest_h"},
  { /* I4BTEST */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "BJTEST", "btest_l"},
  { /* I4BTESTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "BJTEST", "btest_l"},
  { /* I8BTEST */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "BKTEST", "btest_ll"},
  { /* I8BTESTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "BKTEST", "btest_ll"},
  { /* I1MVBITS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "MVBITS", "mvbits_byte"},
  { /* I2MVBITS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "MVBITS", "mvbits_short"},
  { /* I4MVBITS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "MVBITS", "mvbits_long"},
  { /* I8MVBITS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "MVBITS", "mvbits_long_long"},
  { /* I1SHL */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, "_I4SHL", "LSHIFT", "shft_b"},
  { /* I2SHL */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, "_I4SHL", "LSHIFT", "shft_h"},
  { /* I1SHR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "RSHIFT", "rshft_b"},
  { /* I2SHR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "RSHIFT", "rshft_h"},
  { /* I1SHFT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "ISHFT", "shft_b"},
  { /* I2SHFT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IISHFT", "shft_h"},
  { /* I2SHFTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IISHFT", "shft_h"},
  { /* I4SHFT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JISHFT", "shft_l"},
  { /* I4SHFTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JISHFT", "shft_l"},
  { /* I8SHFT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KISHFT", "shft_ll"},
  { /* I8SHFTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KISHFT", "shft_ll"},
  { /* I1SHFTC */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "ISHFTC", "shftc_b"},
  { /* I2SHFTC */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IISHFTC", "shftc_h"},
  { /* I2SHFTCe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IISHFTC", "shftc_h"},
  { /* I4SHFTC */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JISHFTC", "shftc_l"},
  { /* I4SHFTCe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JISHFTC", "shftc_l"},
  { /* I8SHFTC */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KISHFTC", "shftc_ll"},
  { /* I8SHFTCe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KISHFTC", "shftc_ll"},
  { /* I4CLEN */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LEN", "i_len"},
  { /* I4CLENe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LEN", "i_len"},
  { /* I4CINDEX */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "INDEX", "i_indx"},
  { /* I4CINDEXe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "INDEX", "i_indx"},
  { /* CLGE */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LGE", "l_ge"},
  { /* CLGEe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LGE", "l_ge"},
  { /* CLGT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LGT", "l_gt"},
  { /* CLGTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LGT", "l_gt"},
  { /* CLLE */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LLE", "l_le"},
  { /* CLLEe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LLE", "l_le"},
  { /* CLLT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LLT", "l_lt"},
  { /* CLLTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LLT", "l_lt"},
  { /* F4EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "EXP", "expf"},
  { /* F4EXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "EXP", "r_exp"},
  { /* F8EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DEXP", "exp"},
  { /* F8EXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DEXP", "d_exp"},
  { /* FQEXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QEXP", "__qexp"},
  { /* FQEXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QEXP", "__q_exp"},
  { /* C4EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CEXP", "__cexp"},
  { /* C4EXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CEXP", "c_exp_"},
  { /* C8EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZEXP", "__zexp"},
  { /* C8EXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZEXP", "z_exp_"},
  { /* CQEXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQEXP", "__cqexp"},
  { /* CQEXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQEXP", "__cq_exp"},
  { /* F4LOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ALOG", "logf"},
  { /* F4LOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ALOG", "r_log"},
  { /* F8LOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DLOG", "log"},
  { /* F8LOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DLOG", "d_log"},
  { /* FQLOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QLOG", "__qlog"},
  { /* FQLOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QLOG", "__q_log"},
  { /* C4LOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CLOG", "__clog"},
  { /* C4LOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CLOG", "c_log_"},
  { /* C8LOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZLOG", "__zlog"},
  { /* C8LOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZLOG", "z_log_"},
  { /* CQLOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQLOG", "__cqlog"},
  { /* CQLOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQLOG", "__cq_log"},
  { /* F4LOG10 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ALOG10", "log10f"},
  { /* F4LOG10e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ALOG10", "r_lg10"},
  { /* F8LOG10 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DLOG10", "log10"},
  { /* F8LOG10e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DLOG10", "d_lg10"},
  { /* FQLOG10 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QLOG10", "log10l"},
  { /* FQLOG10e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QLOG10", "__q_lg10"},
  { /* F4COS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "COS", "cosf"},
  { /* F4COSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "COS", "r_cos"},
  { /* F8COS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DCOS", "cos"},
  { /* F8COSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DCOS", "d_cos"},
  { /* FQCOS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QCOS", "__qcos"},
  { /* FQCOSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QCOS", "__q_cos"},
  { /* C4COS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CCOS", "__ccos"},
  { /* C4COSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CCOS", "c_cos_"},
  { /* C8COS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZCOS", "__zcos"},
  { /* C8COSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZCOS", "z_cos_"},
  { /* CQCOS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQCOS", "__cqcos"},
  { /* CQCOSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQCOS", "__cq_cos"},
  { /* F4SIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SIN", "sinf"},
  { /* F4SINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SIN", "r_sin"},
  { /* F8SIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSIN", "sin"},
  { /* F8SINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSIN", "d_sin"},
  { /* FQSIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSIN", "__qsin"},
  { /* FQSINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSIN", "__q_sin"},
  { /* C4SIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CSIN", "__csin"},
  { /* C4SINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CSIN", "c_sin_"},
  { /* C8SIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZSIN", "__zsin"},
  { /* C8SINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZSIN", "z_sin_"},
  { /* CQSIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQSIN", "__cqsin"},
  { /* CQSINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQSIN", "__cq_sin"},
  { /* F4CIS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CIS", "__rcis"},
  { /* F4CISe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CIS", "r_cis"},
  { /* F8CIS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "DCIS", "__dcis"},
  { /* F8CISe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "DCIS", "d_cis"},
  { /* FQCIS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "QCIS", "__qcis"},
  { /* FQCISe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "QCIS", "q_cis"},
  { /* F4TAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "TAN", "tanf"},
  { /* F4TANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "TAN", "r_tan"},
  { /* F8TAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DTAN", "tan"},
  { /* F8TANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DTAN", "d_tan"},
  { /* FQTAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QTAN", "__qtan"},
  { /* FQTANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QTAN", "__q_tan"},
  { /* F4COSD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "COSD", "__rcosd"},
  { /* F4COSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "COSD", "r_cosd"},
  { /* F8COSD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DCOSD", "__dcosd"},
  { /* F8COSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DCOSD", "d_cosd"},
  { /* FQCOSD */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QCOSD", "__q_cosd"},
  { /* FQCOSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QCOSD", "__q_cosd"},
  { /* F4SIND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SIND", "__rsind"},
  { /* F4SINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SIND", "r_sind"},
  { /* F8SIND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSIND", "__dsind"},
  { /* F8SINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSIND", "d_sind"},
  { /* FQSIND */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSIND", "__q_sind"},
  { /* FQSINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSIND", "__q_sind"},
  { /* F4TAND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "TAND", "__rtand"},
  { /* F4TANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "TAND", "r_tand"},
  { /* F8TAND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DTAND", "__dtand"},
  { /* F8TANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DTAND", "d_tand"},
  { /* FQTAND */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QTAND", "__q_tand"},
  { /* FQTANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QTAND", "__q_tand"},
  { /* F4COSH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "COSH", "coshf"},
  { /* F4COSHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "COSH", "r_cosh"},
  { /* F8COSH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DCOSH", "cosh"},
  { /* F8COSHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DCOSH", "d_cosh"},
  { /* FQCOSH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QCOSH", "__qcosh"},
  { /* FQCOSHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QCOSH", "__q_cosh"},
  { /* F4SINH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SINH", "sinhf"},
  { /* F4SINHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SINH", "r_sinh"},
  { /* F8SINH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSINH", "sinh"},
  { /* F8SINHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSINH", "d_sinh"},
  { /* FQSINH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSINH", "__qsinh"},
  { /* FQSINHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSINH", "__q_sinh"},
  { /* F4TANH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "TANH", "tanhf"},
  { /* F4TANHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "TANH", "r_tanh"},
  { /* F8TANH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DTANH", "tanh"},
  { /* F8TANHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DTANH", "d_tanh"},
  { /* FQTANH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QTANH", "__qtanh"},
  { /* FQTANHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QTANH", "__q_tanh"},
  { /* F4ACOS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ACOS", "acosf"},
  { /* F4ACOSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ACOS", "r_acos"},
  { /* F8ACOS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DACOS", "acos"},
  { /* F8ACOSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DACOS", "d_acos"},
  { /* FQACOS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QACOS", "__qacos"},
  { /* FQACOSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QACOS", "__q_acos"},
  { /* F4ASIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ASIN", "asinf"},
  { /* F4ASINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ASIN", "r_asin"},
  { /* F8ASIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DASIN", "asin"},
  { /* F8ASINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DASIN", "d_asin"},
  { /* FQASIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QASIN", "__qasin"},
  { /* FQASINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QASIN", "__q_asin"},
  { /* F4ATAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAN", "atanf"},
  { /* F4ATANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAN", "r_atan"},
  { /* F8ATAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAN", "atan"},
  { /* F8ATANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAN", "d_atan"},
  { /* FQATAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAN", "__qatan"},
  { /* FQATANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAN", "__q_atan"},
  { /* F4ACOSD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ACOSD", "__racosd"},
  { /* F4ACOSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ACOSD", "r_acosd"},
  { /* F8ACOSD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DACOSD", "__dacosd"},
  { /* F8ACOSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DACOSD", "d_acosd"},
  { /* FQACOSD */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QACOSD", "__q_acosd"},
  { /* FQACOSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QACOSD", "__q_acosd"},
  { /* F4ASIND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ASIND", "__rasind"},
  { /* F4ASINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ASIND", "r_asind"},
  { /* F8ASIND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DASIND", "__dasind"},
  { /* F8ASINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DASIND", "d_asind"},
  { /* FQASIND */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QASIND", "__q_asind"},
  { /* FQASINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QASIND", "__q_asind"},
  { /* F4ATAND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAND", "__ratand"},
  { /* F4ATANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAND", "r_atand"},
  { /* F8ATAND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAND", "__datand"},
  { /* F8ATANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAND", "d_atand"},
  { /* FQATAND */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAND", "__q_atand"},
  { /* FQATANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAND", "__q_atand"},
  { /* F4ATAN2 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAN2", "atan2f"},
  { /* F4ATAN2e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAN2", "r_atn2"},
  { /* F8ATAN2 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAN2", "atan2"},
  { /* F8ATAN2e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAN2", "d_atn2"},
  { /* FQATAN2 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAN2", "__qatan2"},
  { /* FQATAN2e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAN2", "__q_atn2"},
  { /* F4ATAN2D */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAN2D", "__ratn2d"},
  { /* F4ATAN2De */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAN2D", "r_atn2d"},
  { /* F8ATAN2D */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAN2D", "__datn2d"},
  { /* F8ATAN2De */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAN2D", "d_atn2d"},
  { /* FQATAN2D */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAN2D", "__qatan2d"},
  { /* FQATAN2De */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAN2D", "__q_atn2d"},
  { /* U4I4ALLOCA */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_alloca", "ALLOCA", NULL},
  { /* U8I8ALLOCA */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_alloca", "ALLOCA", NULL},
  { /* U4I4MALLOC */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, NULL, "MALLOC", "malloc"},
  { /* U8I8MALLOC */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, NULL, "MALLOC", "malloc"},
  { /* U4FREE */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "FREE", "free"},
  { /* U8FREE */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "FREE", "free"},
  { /* MDATE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "DATE", "date_vms"},
  { /* I1DATE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "IDATE", "idate_byte"},
  { /* I2DATE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "IDATE", "idate_short"},
  { /* I4DATE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "IDATE", "idate_long"},
  { /* I8DATE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "IDATE", "idate_long_long"},
  { /* I1ERRSNS */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ERRSNS", "errsns_byte"},
  { /* I2ERRSNS */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ERRSNS", "errsns_short"},
  { /* I4ERRSNS */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ERRSNS", "errsns_long"},
  { /* I8ERRSNS */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ERRSNS", "errsns_long_long"},
  { /* VEXIT */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "EXIT", "exit_noargs"},
  { /* I1EXIT */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "EXIT", "exit_byte"},
  { /* I2EXIT */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "EXIT", "exit_short"},
  { /* I4EXIT */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "EXIT", "exit_long"},
  { /* I8EXIT */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "EXIT", "exit_long_long"},
  { /* TIME */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "TIME", "time_vms"},
  { /* F4SECNDS */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SECNDS", "secnds_vms"},
  { /* F8SECNDS */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "SECNDS", "dsecnds_vms"},
  { /* PAUSE */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "PAUSE", "s_paus"},
  { /* STOP */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "STOP", "s_stop"},
  { /* F4I4RAN */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "_RANF_4", "_RANF_4"},
  { /* F4I8RAN */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, NULL, NULL},
  { /* F8I4RAN */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "_RANF_8", "_RANF_8"},
  { /* F8I8RAN */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, NULL, NULL},
  { /* FQI4RAN */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, NULL, NULL},
  { /* FQI8RAN */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, NULL, NULL},
  { /* I4DIVFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "_I4DIVFLOOR", "INTRN_I4DIVFLOOR", NULL},
  { /* I8DIVFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "_I8DIVFLOOR", "INTRN_I8DIVFLOOR", NULL},
  { /* U4DIVFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "_U4DIVFLOOR", NULL, NULL},
  { /* U8DIVFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, "_U8DIVFLOOR", NULL, NULL},
  { /* I4DIVCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "_I4DIVCEIL", "INTRN_I4DIVCEIL", NULL},
  { /* I8DIVCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "_I8DIVCEIL", "INTRN_I8DIVCEIL", NULL},
  { /* U4DIVCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "_U4DIVCEIL", NULL, NULL},
  { /* U8DIVCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, "_U8DIVCEIL", NULL, NULL},
  { /* I4MODFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "_I4MODFLOOR", "INTRN_I4MODFLOOR", NULL},
  { /* I8MODFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "_I8MODFLOOR", "INTRN_I8MODFLOOR", NULL},
  { /* U4MODFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "_U4MODFLOOR", NULL, NULL},
  { /* U8MODFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, "_U8MODFLOOR", NULL, NULL},
  { /* I4MODCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "_I4MODCEIL", "INTRN_I4MODCEIL", NULL},
  { /* I8MODCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "_I8MODCEIL", "INTRN_I8MODCEIL", NULL},
  { /* U4MODCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "_U4MODCEIL", NULL, NULL},
  { /* U8MODCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, "_U8MODCEIL", NULL, NULL},
  { /* U4I4SETSTACKPOINTER */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_setstackpointer", "INTRN_U4I4SETSTACKPOINTER", NULL},
  { /* U8I8SETSTACKPOINTER */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_setstackpointer", "INTRN_U8I8SETSTACKPOINTER", NULL},
  { /* U4READSTACKPOINTER */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_readstackpointer", "INTRN_U4READSTACKPOINTER", NULL},
  { /* U8READSTACKPOINTER */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_readstackpointer", "INTRN_U8READSTACKPOINTER", NULL},
  { /* ADD_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__add_and_fetch", "ADD_AND_FETCH_I4", NULL},
  { /* SUB_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__sub_and_fetch", "SUB_AND_FETCH_I4", NULL},
  { /* OR_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__or_and_fetch", "OR_AND_FETCH_I4", NULL},
  { /* XOR_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__xor_and_fetch", "XOR_AND_FETCH_I4", NULL},
  { /* AND_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__and_and_fetch", "AND_AND_FETCH_I4", NULL},
  { /* NAND_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__nand_and_fetch", "NAND_AND_FETCH_I4", NULL},
  { /* FETCH_AND_ADD_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_add", "FETCH_AND_ADD_I4", NULL},
  { /* FETCH_AND_SUB_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_sub", "FETCH_AND_SUB_I4", NULL},
  { /* FETCH_AND_OR_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_or", "FETCH_AND_OR_I4", NULL},
  { /* FETCH_AND_XOR_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_xor", "FETCH_AND_XOR_I4", NULL},
  { /* FETCH_AND_AND_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_and", "FETCH_AND_AND_I4", NULL},
  { /* FETCH_AND_NAND_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_nand", "FETCH_AND_NAND_I4", NULL},
  { /* ADD_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__add_and_fetch", "ADD_AND_FETCH_I8", NULL},
  { /* SUB_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__sub_and_fetch", "SUB_AND_FETCH_I8", NULL},
  { /* OR_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__or_and_fetch", "OR_AND_FETCH_I8", NULL},
  { /* XOR_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__xor_and_fetch", "XOR_AND_FETCH_I8", NULL},
  { /* AND_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__and_and_fetch", "AND_AND_FETCH_I8", NULL},
  { /* NAND_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__nand_and_fetch", "NAND_AND_FETCH_I8", NULL},
  { /* FETCH_AND_ADD_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_add", "FETCH_AND_ADD_I8", NULL},
  { /* FETCH_AND_SUB_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_sub", "FETCH_AND_SUB_I8", NULL},
  { /* FETCH_AND_OR_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_or", "FETCH_AND_OR_I8", NULL},
  { /* FETCH_AND_XOR_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_xor", "FETCH_AND_XOR_I8", NULL},
  { /* FETCH_AND_AND_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_and", "FETCH_AND_AND_I8", NULL},
  { /* FETCH_AND_NAND_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_nand", "FETCH_AND_NAND_I8", NULL},
  { /* LOCK_TEST_AND_SET_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__lock_test_and_set", "LOCK_TEST_AND_SET_I4", NULL},
  { /* LOCK_TEST_AND_SET_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__lock_test_and_set", "LOCK_TEST_AND_SET_I8", NULL},
  { /* LOCK_RELEASE_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "__lock_release", "LOCK_RELEASE_I4", NULL},
  { /* LOCK_RELEASE_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "__lock_release", "LOCK_RELEASE_I8", NULL},
  { /* COMPARE_AND_SWAP_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__compare_and_swap", "COMPARE_AND_SWAP_I4", NULL},
  { /* COMPARE_AND_SWAP_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__compare_and_swap", "COMPARE_AND_SWAP_I8", NULL},
  { /* SYNCHRONIZE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "__synchronize", "SYNCHRONIZE", NULL},
  { /* RETURN_ADDRESS */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_PV, "__return_address", "GET_RETURN_ADDRESS", NULL},
  { /* U4I1ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4I2ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4I4ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4I8ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4F4ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4F8ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4FQADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4C4ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4C8ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4CQADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4VADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U8I1ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8I2ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8I4ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8I8ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8F4ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8F8ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8FQADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8C4ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8C8ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8CQADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8VADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* I4VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, NULL},
  { /* I8VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, NULL, NULL},
  { /* U4VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, NULL},
  { /* U8VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, NULL, NULL},
  { /* F4VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, NULL, NULL},
  { /* F8VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, NULL, NULL},
  { /* FQVALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, NULL, NULL},
  { /* C4VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, NULL, NULL},
  { /* C8VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, NULL, NULL},
  { /* CQVALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, NULL, NULL},
  { /* BCOPY */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "bcopy", "BCOPY", "bcopy"},
  { /* BCMP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "bcmp", "BCMP", "bcmp"},
  { /* BZERO */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "bzero", "BZERO", "bzero"},
  { /* MEMCCPY */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "memccpy", "MEMCCPY", "memccpy"},
  { /* MEMCHR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "memchr", "MEMCHR", "memchr"},
  { /* MEMCMP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "memcmp", "MEMCMP", "memcmp"},
  { /* MEMCPY */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "memcpy", "MEMCPY", "memcpy"},
  { /* MEMMOVE */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "memmove", "MEMMOVE", "memmove"},
  { /* MEMSET */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "memset", "MEMSET", "memset"},
  { /* STRCMP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "strcmp", "STRCMP", "strcmp"},
  { /* STRNCMP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "strncmp", "STRNCMP", "strncmp"},
  { /* STRCPY */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PC, "strcpy", "STRCPY", "strcpy"},
  { /* STRNCPY */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PC, "strncpy", "STRNCPY", "strncpy"},
  { /* STRLEN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_SZT, "strlen", "STRLEN", "strlen"},
  { /* PRINTF */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "printf", "PRINTF", "printf"},
  { /* FPRINTF */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "fprintf", "FPRINTF", "fprintf"},
  { /* SPRINTF */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "sprintf", "SPRINTF", "sprintf"},
  { /* PRINTW */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "printw", "PRINTW", "printw"},
  { /* SCANF */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "scanf", "SCANF", "scanf"},
  { /* FSCANF */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "fscanf", "FSCANF", "fscanf"},
  { /* SSCANF */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "sscanf", "SSCANF", "sscanf"},
  { /* FPUTC */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "fputc", "FPUTC", "fputc"},
  { /* FPUTS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "fputs", "FPUTS", "fputs"},
  { /* FGETC */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "fgetc", "FGETC", "fgetc"},
  { /* FGETS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "fgets", "FGETS", "fgets"},
  { /* F4VACOS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vacosf", "VACOSF", "vacosf"},
  { /* F8VACOS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vacos", "VACOS", "vacos"},
  { /* F4VASIN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vasinf", "VASINF", "vasinf"},
  { /* F8VASIN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vasin", "VASIN", "vasin"},
  { /* F4VATAN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vatanf", "VATANF", "vatanf"},
  { /* F8VATAN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vatan", "VATAN", "vatan"},
  { /* F4VCOS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vcosf", "VCOSF", "vcosf"},
  { /* F8VCOS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vcos", "VCOS", "vcos"},
  { /* F4VEXP */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vexpf", "VEXPF", "vexpf"},
  { /* F8VEXP */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vexp", "VEXP", "vexp"},
  { /* F4VLOG */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vlogf", "VLOGF", "vlogf"},
  { /* F8VLOG */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vlog", "VLOG", "vlog"},
  { /* F4VSIN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vsinf", "VSINF", "vsinf"},
  { /* F8VSIN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vsin", "VSIN", "vsin"},
  { /* F4VSQRT */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vsqrtf", "VSQRTF", "vsqrtf"},
  { /* F8VSQRT */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vsqrt", "VSQRT", "vsqrt"},
  { /* F4VTAN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vtanf", "VTANF", "vtanf"},
  { /* F8VTAN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vtan", "VTAN", "vtan"},
  { /* NARY_ADD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* NARY_MPY */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* U4I4TRAPUV_MALLOC */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, NULL, "TRAPUV_MALLOC", "__trapuv_malloc"},
  { /* U8I8TRAPUV_MALLOC */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, NULL, "TRAPUV_MALLOC", "__trapuv_malloc"},
  { /* F77_BOUNDS_ERR */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, NULL, "s_rnge"},
  { /* DSM_NUMTHREADS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_NUMTHREADS", "dsm_numthreads"},
  { /* DSM_CHUNKSIZE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_CHUNKSIZE", "dsm_chunksize"},
  { /* DSM_THIS_CHUNKSIZE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_THIS_CHUNKSIZE", "dsm_this_chunksize"},
  { /* DSM_REM_CHUNKSIZE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_REM_CHUNKSIZE", "dsm_rem_chunksize"},
  { /* DSM_NUMCHUNKS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_NUMCHUNKS", "dsm_numchunks"},
  { /* DSM_THIS_THREADNUM */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_THIS_THREADNUM", "dsm_this_threadnum"},
  { /* DSM_DISTRIBUTION_BLOCK */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_DISTRIBUTION_BLOCK", "dsm_distribution_block"},
  { /* DSM_DISTRIBUTION_STAR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_DISTRIBUTION_STAR", "dsm_distribution_star"},
  { /* DSM_ISRESHAPED */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_ISRESHAPED", "dsm_isreshaped"},
  { /* DSM_ISDISTRIBUTED */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_ISDISTRIBUTED", "dsm_isdistributed"},
  { /* DSM_THIS_STARTINDEX */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_THIS_STARTINGINDEX", "dsm_this_startingindex"},
  { /* DSM_DISTRIBUTION_CYCLIC */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_DISTRIBUTION_CYCLIC", "dsm_distribution_cyclic"},
  { /* MPY_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__mpy_and_fetch", "MPY_AND_FETCH_I4", NULL},
  { /* MIN_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__min_and_fetch", "MIN_AND_FETCH_I4", NULL},
  { /* MAX_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__max_and_fetch", "MAX_AND_FETCH_I4", NULL},
  { /* FETCH_AND_MPY_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_mpy", "FETCH_AND_MPY_I4", NULL},
  { /* FETCH_AND_MIN_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_min", "FETCH_AND_MIN_I4", NULL},
  { /* FETCH_AND_MAX_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_max", "FETCH_AND_MAX_I4", NULL},
  { /* MPY_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__mpy_and_fetch", "MPY_AND_FETCH_I8", NULL},
  { /* MIN_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__min_and_fetch", "MIN_AND_FETCH_I8", NULL},
  { /* MAX_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__max_and_fetch", "MAX_AND_FETCH_I8", NULL},
  { /* FETCH_AND_MPY_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_mpy", "FETCH_AND_MPY_I8", NULL},
  { /* FETCH_AND_MIN_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_min", "FETCH_AND_MIN_I8", NULL},
  { /* FETCH_AND_MAX_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_max", "FETCH_AND_MAX_I8", NULL},
  { /* ADD_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__add_and_fetch", "ADD_AND_FETCH_F4", NULL},
  { /* SUB_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__sub_and_fetch", "SUB_AND_FETCH_F4", NULL},
  { /* OR_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__or_and_fetch", "OR_AND_FETCH_F4", NULL},
  { /* XOR_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__xor_and_fetch", "XOR_AND_FETCH_F4", NULL},
  { /* AND_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__and_and_fetch", "AND_AND_FETCH_F4", NULL},
  { /* NAND_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__nand_and_fetch", "NAND_AND_FETCH_F4", NULL},
  { /* MPY_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__mpy_and_fetch", "MPY_AND_FETCH_F4", NULL},
  { /* MIN_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__min_and_fetch", "MIN_AND_FETCH_F4", NULL},
  { /* MAX_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__max_and_fetch", "MAX_AND_FETCH_F4", NULL},
  { /* FETCH_AND_ADD_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_add", "FETCH_AND_ADD_F4", NULL},
  { /* FETCH_AND_SUB_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_sub", "FETCH_AND_SUB_F4", NULL},
  { /* FETCH_AND_OR_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_or", "FETCH_AND_OR_F4", NULL},
  { /* FETCH_AND_XOR_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_xor", "FETCH_AND_XOR_F4", NULL},
  { /* FETCH_AND_AND_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_and", "FETCH_AND_AND_F4", NULL},
  { /* FETCH_AND_NAND_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_nand", "FETCH_AND_NAND_F4", NULL},
  { /* FETCH_AND_MPY_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_mpy", "FETCH_AND_MPY_F4", NULL},
  { /* FETCH_AND_MIN_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_min", "FETCH_AND_MIN_F4", NULL},
  { /* FETCH_AND_MAX_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_max", "FETCH_AND_MAX_F4", NULL},
  { /* ADD_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__add_and_fetch", "ADD_AND_FETCH_F8", NULL},
  { /* SUB_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__sub_and_fetch", "SUB_AND_FETCH_F8", NULL},
  { /* OR_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__or_and_fetch", "OR_AND_FETCH_F8", NULL},
  { /* XOR_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__xor_and_fetch", "XOR_AND_FETCH_F8", NULL},
  { /* AND_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__and_and_fetch", "AND_AND_FETCH_F8", NULL},
  { /* NAND_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__nand_and_fetch", "NAND_AND_FETCH_F8", NULL},
  { /* MPY_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__mpy_and_fetch", "MPY_AND_FETCH_F8", NULL},
  { /* MIN_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__min_and_fetch", "MIN_AND_FETCH_F8", NULL},
  { /* MAX_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__max_and_fetch", "MAX_AND_FETCH_F8", NULL},
  { /* FETCH_AND_ADD_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_add", "FETCH_AND_ADD_F8", NULL},
  { /* FETCH_AND_SUB_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_sub", "FETCH_AND_SUB_F8", NULL},
  { /* FETCH_AND_OR_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_or", "FETCH_AND_OR_F8", NULL},
  { /* FETCH_AND_XOR_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_xor", "FETCH_AND_XOR_F8", NULL},
  { /* FETCH_AND_AND_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_and", "FETCH_AND_AND_F8", NULL},
  { /* FETCH_AND_NAND_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_nand", "FETCH_AND_NAND_F8", NULL},
  { /* FETCH_AND_MPY_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_mpy", "FETCH_AND_MPY_F8", NULL},
  { /* FETCH_AND_MIN_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_min", "FETCH_AND_MIN_F8", NULL},
  { /* FETCH_AND_MAX_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_max", "FETCH_AND_MAX_F8", NULL},
  { /* LOCK_ACQUIRE_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "__lock_acquire", "LOCK_ACQUIRE_I4", NULL},
  { /* LOCK_ACQUIRE_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "__lock_acquire", "LOCK_ACQUIRE_I8", NULL},
  { /* F90_STACKTEMPALLOC */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* F90_HEAPTEMPALLOC */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* F90_STACKTEMPFREE */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* F90_HEAPTEMPFREE */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* F4EXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F4EXPONENT", "_EXPONENT_4"},
  { /* F8EXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F8EXPONENT", "_EXPONENT"},
  { /* FQEXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQEXPONENT", "_EXPONENT_16"},
  { /* F4FRACTION */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4FRACTION", "_FRACTION_4"},
  { /* F8FRACTION */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8FRACTION", "_FRACTION"},
  { /* FQFRACTION */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQFRACTION", "_FRACTION_16"},
  { /* F4MODULO */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4MODULO", "_modulo4"},
  { /* F8MODULO */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8MODULO", "_modulo8"},
  { /* FQMODULO */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQMODULO", "_moduloq"},
  { /* F4NEAREST */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4NEAREST", "_NEAREST_4"},
  { /* F8NEAREST */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8NEAREST", "_NEAREST"},
  { /* FQNEAREST */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQNEAREST", "_NEAREST_16"},
  { /* F4RRSPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4RRSPACING", "_RRSPACING_4"},
  { /* F8RRSPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8RRSPACING", "_RRSPACING"},
  { /* FQRRSPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQRRSPACING", "_RRSPACING_16"},
  { /* F4SCALE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4SCALE", "_SCALE_4"},
  { /* F8SCALE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8SCALE", "_SCALE"},
  { /* FQSCALE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQSCALE", "_SCALE_16"},
  { /* F4SET_EXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4SET_EXPONENT", "_SET_EXPONENT_4"},
  { /* F8SET_EXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8SET_EXPONENT", "_SET_EXPONENT"},
  { /* FQSET_EXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQSET_EXPONENT", "_SET_EXPONENT_16"},
  { /* F4SPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4SPACING", "_SPACING_4"},
  { /* F8SPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8SPACING", "_SPACING"},
  { /* FQSPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQSPACING", "_SPACING_16"},
  { /* F4NEXTAFTER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4NEXTAFTER", "_IEEE_NEXT_AFTER_H"},
  { /* F8NEXTAFTER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8NEXTAFTER", "nextafter"},
  { /* FQNEXTAFTER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQNEXTAFTER", "qnextafter"},
  { /* F4ISNAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4ISNAN", "isnanf"},
  { /* F8ISNAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8ISNAN", "isnan"},
  { /* FQISNAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQISNAN", "isnanq"},
  { /* F4SCALB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4SCALB", "ldexp"},
  { /* F8SCALB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8SCALB", "ldexp"},
  { /* FQSCALB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQSCALB", "qldexp"},
  { /* F4IEEE_REMAINDER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4IEEE_REMAINDER", "drem"},
  { /* F8IEEE_REMAINDER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8IEEE_REMAINDER", "drem"},
  { /* FQIEEE_REMAINDER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQIEEE_REMAINDER", "_IEEE_REMAINDER_Q"},
  { /* F4LOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4LOGB", "logb"},
  { /* F8LOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8LOGB", "logb"},
  { /* FQLOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQLOGB", "__qlogb"},
  { /* F4ILOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F4ILOGB", "__ilogbf"},
  { /* F8ILOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F8ILOGB", "__ilogb"},
  { /* FQILOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQILOGB", "__iqlogb"},
  { /* F4FPCLASS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F4FPCLASS", "_fp_class_f"},
  { /* F8FPCLASS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F8FPCLASS", "_fp_class_d"},
  { /* FQFPCLASS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQFPCLASS", "_fp_class_q"},
  { /* F4FINITE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F4FINITE", "finite"},
  { /* F8FINITE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F8FINITE", "finite"},
  { /* FQFINITE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQFINITE", "__qfinite"},
  { /* F4UNORDERED */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F4UNORDERED", "unordered"},
  { /* F8UNORDERED */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F8UNORDERED", "unordered"},
  { /* FQUNORDERED */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQUNORDERED", "unorderedl"},
  { /* I1POPCNT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I1POPCNT", "__popcnt1"},
  { /* I2POPCNT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I2POPCNT", "__popcnt2"},
  { /* I4POPCNT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I4POPCNT", "__popcnt4"},
  { /* I8POPCNT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I8POPCNT", "__popcnt8"},
  { /* I1LEADZ */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I1LEADZ", "__leadz1"},
  { /* I2LEADZ */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I2LEADZ", "__leadz2"},
  { /* I4LEADZ */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I4LEADZ", "__leadz4"},
  { /* I8LEADZ */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I8LEADZ", "__leadz8"},
  { /* LENTRIM */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "LENTRIM", "i_lentrim"},
  { /* F90INDEX */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F90INDEX", "_index90"},
  { /* SCAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "SCAN", "_scan90"},
  { /* VERIFY */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "VERIFY", "_verify90"},
  { /* ADJUSTL */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ADJUSTL", "_F90_ADJUSTL"},
  { /* ADJUSTR */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ADJUSTR", "_F90_ADJUSTR"},
  { /* GET_IEEE_EXCEPTIONS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "GET_IEEE_EXCEPTIONS", "__get_ieee_exceptions"},
  { /* GET_IEEE_INTERRUPTS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "GET_IEEE_INTERRUPTS", "__get_ieee_interrupts"},
  { /* GET_IEEE_ROUNDING_MODE */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "GET_IEEE_ROUNDING_MODE", "fpgetround"},
  { /* GET_IEEE_STATUS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "GET_IEEE_STATUS", "__get_ieee_status"},
  { /* SET_IEEE_EXCEPTIONS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SET_IEEE_EXCEPTIONS", "__set_ieee_exceptions"},
  { /* SET_IEEE_EXCEPTION */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SET_IEEE_EXCEPTION", "__set_ieee_exception"},
  { /* SET_IEEE_INTERRUPTS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SET_IEEE_INTERRUPTS", "__set_ieee_interrupts"},
  { /* SET_IEEE_ROUNDING_MODE */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SET_IEEE_ROUNDING_MODE", "fpsetround"},
  { /* SET_IEEE_STATUS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SET_IEEE_STATUS", "__set_ieee_status"},
  { /* ENABLE_IEEE_INTERRUPT */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ENABLE_IEEE_INTERRUPT", "__enable_ieee_interrupt"},
  { /* DISABLE_IEEE_INTERRUPT */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "DISABLE_IEEE_INTERRUPT", "__disable_ieee_interrupt"},
  { /* TEST_IEEE_EXCEPTION */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "TEST_IEEE_EXCEPTION", "__test_ieee_exception"},
  { /* TEST_IEEE_INTERRUPT */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "TEST_IEEE_INTERRUPT", "__test_ieee_interrupt"},
  { /* MATMUL */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* SPREAD */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* RESHAPE */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* TRANSPOSE */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* ALL */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* ANY */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* COUNT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* PRODUCT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* SUM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* EOSHIFT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* MAXVAL */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* MINVAL */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* MAXLOC */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* MINLOC */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* CSHIFT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* DOT_PRODUCT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* PACK */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* UNPACK */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* MERGE */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* CHAR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* MP_IN_PARALLEL_REGION */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__mp_in_parallel_region", "__mp_in_parallel_region$", "mp_in_parallel_region"},
  { /* RT_ERR */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, NULL, "__C_runtime_error"},
  { /* OMP_DO_WORKSHARING */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__omp_do_worksharing", "__omp_do_worksharing$", "omp_do_worksharing"},
  { /* OMP_TEST_LOCK */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_TEST_LOCK", "omp_test_lock_"},
  { /* OMP_GET_NUM_THREADS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_GET_NUM_THREADS", "omp_get_num_threads_"},
  { /* OMP_GET_MAX_THREADS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_GET_MAX_THREADS", "omp_get_max_threads_"},
  { /* OMP_GET_THREAD_NUM */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_GET_THREAD_NUM", "omp_get_thread_num_"},
  { /* OMP_GET_NUM_PROCS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_GET_NUM_PROCS", "omp_get_num_procs_"},
  { /* OMP_IN_PARALLEL */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_IN_PARALLEL", "omp_in_parallel_"},
  { /* OMP_GET_DYNAMIC */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_GET_DYNAMIC", "omp_get_dynamic_"},
  { /* OMP_GET_NESTED */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_GET_NESTED", "omp_get_nested_"},
  { /* I1IEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "I1IEEE_INT", "_IEEE_INT_D_I1"},
  { /* I2IEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "I2IEEE_INT", "_IEEE_INT_D_I2"},
  { /* I4IEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I4IEEE_INT", "_IEEE_INT_D_I4"},
  { /* I8IEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "I8IEEE_INT", "_IEEE_INT_D_I8"},
  { /* F4IEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4IEEE_INT", "_IEEE_INT_D_H"},
  { /* F8IEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8IEEE_INT", "_IEEE_INT_D_R"},
  { /* FQIEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQIEEE_INT", "_IEEE_INT_D_D"},
  { /* F90BOUNDS_CHECK */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "F90BOUNDS_CHECK", "__f90_bounds_check"},
  { /* F90_DYNAMICTEMPALLOC */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* F90_DYNAMICTEMPFREE */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* F90CONFORM_CHECK */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "F90CONFORM_CHECK", "__f90_conform_check"},
  { /* C_F4FLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, "floorf", "C_F4FLOOR", "floorf"},
  { /* C_F8FLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, "floor", "C_F8FLOOR", "floor"},
  { /* C_FQFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, "floorl", "C_FQFLOOR", "floorl"},
  { /* C_F4CEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, "ceilf", "C_F4CEIL", "ceilf"},
  { /* C_F8CEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, "ceil", "C_F8CEIL", "ceil"},
  { /* C_FQCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, "ceill", "C_FQCEIL", "ceill"},
  { /* C_F4TRUNC */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, "truncf", "C_F4TRUNC", "truncf"},
  { /* C_F8TRUNC */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, "trunc", "C_F8TRUNC", "trunc"},
  { /* C_FQTRUNC */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, "truncl", "C_FQTRUNC", "truncl"},
  { /* I4DSHIFTL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__dshiftl4", "I4DSHIFTL", "__dshiftl4"},
  { /* I8DSHIFTL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__dshiftl8", "I8DSHIFTL", "__dshiftl8"},
  { /* I4DSHIFTR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__dshiftr4", "I4DSHIFTR", "__dshiftr4"},
  { /* I8DSHIFTR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__dshiftr8", "I8DSHIFTR", "__dshiftr8"},
  { /* I4GBIT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__gbit4", "I4GBIT", "__gbit4"},
  { /* I8GBIT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__gbit8", "I8GBIT", "__gbit8"},
  { /* I4GBITS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__gbits4", "I4GBITS", "__gbits4"},
  { /* I8GBITS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__gbits8", "I8GBITS", "__gbits8"},
  { /* I4MASK */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__mask4", "I4MASK", "__mask4"},
  { /* I8MASK */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__mask8", "I8MASK", "__mask8"},
  { /* I4MASKL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__maskl4", "I4MASKL", "__maskl4"},
  { /* I8MASKL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__maskl8", "I8MASKL", "__maskl8"},
  { /* I4MASKR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__maskr4", "I4MASKR", "__maskr4"},
  { /* I8MASKR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__maskr8", "I8MASKR", "__maskr8"},
  { /* I4PBIT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__pbit4", "I4PBIT", "__pbit4"},
  { /* I8PBIT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__pbit8", "I8PBIT", "__pbit8"},
  { /* I4PBITS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__pbits4", "I4PBITS", "__pbits4"},
  { /* I8PBITS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__pbits8", "I8PBITS", "__pbits8"},
  { /* I4POPPAR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__poppar4", "I4POPPAR", "__poppar4"},
  { /* I8POPPAR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__poppar8", "I8POPPAR", "__poppar8"},
  { /* I4RTC */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__rtc4", "I4RTC", "__rtc4"},
  { /* I8RTC */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__rtc8", "I8RTC", "__rtc8"},
  { /* GETF_EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I8, "__builtin_getf_exp", NULL, NULL},
  { /* SETF_EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_F10, "__builtin_setf_exp", NULL, NULL},
  { /* GETF_SIG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I8, "__builtin_getf_sig", NULL, NULL},
  { /* SETF_SIG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_F10, "__builtin_setf_sig", NULL, NULL},
  { /* FMERGE_NS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F10, "__builtin_fmerge_ns", "FMERGE_NS", "__builtin_fmerge_ns"},
  { /* FMERGE_S */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F10, "__builtin_fmerge_s", "FMERGE_S", "__builtin_fmerge_s"},
  { /* FMERGE_SE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F10, "__builtin_fmerge_se", "FMERGE_SE", "__builtin_fmerge_se"},
  { /* STOP_F90 */
	BYVAL, NOT_PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "_F90_STOP", "_F90_STOP"},
  { /* F4VLOG10 */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vlog10f", "VLOG10F", "vlog10f"},
  { /* F8VLOG10 */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vlog10", "VLOG10", "vlog10"},
  { /* MODSI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__modsi3", "__modsi3", "__modsi3"},
  { /* UMODSI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "__umodsi3", "__umodsi3", "__umodsi3"},
  { /* DIVSI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__divsi3", "__divsi3", "__divsi3"},
  { /* UDIVSI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "__udivsi3", "__udivsi3", "__udivsi3"},
  { /* MODDI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__moddi3", "__moddi3", "__moddi3"},
  { /* UMODDI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, "__umoddi3", "__umoddi3", "__umoddi3"},
  { /* DIVDI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__divdi3", "__divdi3", "__divdi3"},
  { /* UDIVDI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, "__udivdi3", "__udivdi3", "__udivdi3"},
  { /* DIVSF3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, "__divsf3", "__divsf3", "__divsf3"},
  { /* DIVDF3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, "__divdf3", "__divdf3", "__divdf3"},
#ifdef TARG_IA64
  { /* I4FFS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, "__builtin_ffs", NULL, NULL},
#else
  { /* I4FFS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "ffs", "I4FFS", "ffs"},
#endif
  { /* SINCOSF */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SINCOS", "__sincosf"},
  { /* SINCOS */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SINCOS", "__sincos"},
  { /* SINCOSL */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SINCOS", "__sincosl"},

  /* UPC specific intrinsics */
  /* blocking loads */
  { /* SILD */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, /*NULL*/"UPCR_GET_SHARED_VAL", "SILD", "UPCR_GET_SHARED_VAL"},
  { /* SF4LD */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, /*NULL*/"UPCR_GET_SHARED_FLOAT", "SF4LD", "UPCR_GET_SHARED_FLOAT"},
  { /* SF8LD */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, /*NULL*/"UPCR_GET_SHARED_DOUBLEVAL", "SF8LD", "UPCR_GET_SHARED_DOUBLEVAL"},
  { /* SMLD */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, /*NULL*/"UPCR_GET_SHARED", "SMLD", "UPCR_GET_SHARED"},
  
  /* blocking stores */
  { /* SIST */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, /*NULL*/"UPCR_PUT_SHARED_VAL", "SI1ST", "UPCR_PUT_SHARED_VAL"},
  { /* SF4ST */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, /*NULL*/"UPCR_PUT_SHARED_FLOAT", "SF4ST", "UPCR_PUT_SHARED_FLOAT"},
  { /* SF8ST */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, /*NULL*/"UPCR_PUT_SHARED_DOUBLEVAL", "SF8ST", "UPCR_PUT_SHARED_DOUBLEVAL"},
  { /* SMST */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, /*NULL*/"UPCR_PUT_SHARED", "SMST", "UPCR_PUT_SHARED"},

  /* non-blocking loads */
{ /* SILD_NB */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, /*NULL*/"UPCR_GET_NB_SHARED_VAL", "SILD_NB", "UPCR_GET_NB_SHARED_VAL"},
  { /* SF4LD_NB */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, /*NULL*/"UPCR_GET_NB_SHARED_FLOAT", "SF4LD_NB", "UPCR_GET_NB_SHARED_FLOAT"},
  { /* SF8LD_NB */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, /*NULL*/"UPCR_GET_NB_SHARED_DOUBLE", "SF8LD_NB", "UPCR_GET_NB_SHARED_DOUBLE"},
  { /* SMLD_NB */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, /*NULL*/"UPCR_GET_NB_SHARED", "SMLD_NB", "UPCR_GET_NB_SHARED"},
  
  /* non-blocking stores */
  { /* SIST_NB */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I8, /*NULL*/"UPCR_PUT_NB_SHARED_VAL", "SI1ST", "UPCR_PUT_NB_SHARED_VAL"},
  { /* SF4ST_NB */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I8, /*NULL*/"UPCR_PUT_NB_SHARED_FLOAT", "SF4ST", "UPCR_PUT_NB_SHARED_FLOAT"},
  { /* SF8ST_NB */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I8, /*NULL*/"UPCR_PUT_NB_SHARED_DOUBLE", "SF8ST", "UPCR_PUT_NB_SHARED_DOUBLE"},
  { /* SMST_NB */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I8, /*NULL*/"UPCR_PUT_NB_SHARED", "SMST", "UPCR_PUT_NB_SHARED"},

  /* put/get syncs */
  { /* SYNC_MEM */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_WAIT_SYNCNB", "SYNC_MEM", "UPCR_WAIT_SYNCNB"},
  { /* SYNC_REG */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I8, /*NULL*/"UPCR_WAIT_SYNCNB_VALGET", "SYNC_REG", "UPCR_WAIT_SYNCNB_VALGET"},
  { /* SYNC_FLOAT */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_F4, /*NULL*/"UPCR_WAIT_SYNCNB_VALGET_FLOAT", "SYNC_FLOAT", "UPCR_WAIT_SYNCNB_VALGET_FLOAT"},
  { /* SYNC_DOUBLE */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_F8, /*NULL*/"UPCR_WAIT_SYNCNB_VALGET_DOUBLE", "SYNC_DOUBLE", "UPCR_WAIT_SYNCNB_VALGET_DOUBLE"},
  /* pointer arithmetic */
  { /* SPTRADD */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_M, /*NULL*/"UPCR_ADD_SHARED", "SPTRADD", "UPCR_ADD_SHARED"},
  { /* SPTRDIFF */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_M, /*NULL*/"UPCR_ADD_SHARED", "SPTRDIFF", "UPCR_ADD_SHARED"},
  { /* SCVTADDR */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, /*NULL*/"UPCR_SHARED_TO_LOCAL", "SCVTADDR", "UPCR_SHARED_TO_LOCAL"},
  { /* UPCBAR */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, /*NULL*/"upcr_barrier", "UPCBAR", "upcr_barrier"},
  { /* UPCWA */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, /*NULL*/"upcr_wait", "UPCWAIT", "upcr_wait"},
  { /* UPCNTFY */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, /*NULL*/"upcr_notify", "UPCNTFY", "upcr_notify"},
  { /* UPCIAFFT */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, /*NULL*/"upcr_hasAffinity", "UPCIAFFT", "upcr_hasAffinity"},

  { /* EXIT */
    	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, /*NULL*/"upcr_global_exit", "EXIT", "upcr_global_exit"},
  { /* MYTHREAD */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I4, /*NULL*/"upcr_mythread", "MYTHREAD", "upcr_mythread"},
  { /* THREADS */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I4, /*NULL*/"upcr_threads", "THREADS", "upcr_threads"},
  { /* ALL_ALLOC */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_M, /*NULL*/"UPCR_ALL_ALLOC", "ALL_ALLOC", "UPCR_ALL_ALLOC"},
  { /* GLOBAL_ALLOC */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_M, /*NULL*/"UPCR_GLOBAL_ALLOC", "GLOBAL_ALLOC", "UPCR_GLOBAL_ALLOC"},
  { /* LOCAL_ALLOC */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_M, /*NULL*/"UPCR_LOCAL_ALLOC", "LOCAL_ALLOC", "UPCR_LOCAL_ALLOC"},
  { /* FREE */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_FREE", "FREE", "UPCR_FREE"},
  { /* THREADOF_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I4, /*NULL*/"UPCR_THREADOF_SHARED", "THREADOF_S", "UPCR_THREADOF_SHARED"},
  { /* THREADOF_P */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I4, /*NULL*/"UPCR_THREADOF_PSHARED", "THREADOF_P", "UPCR_THREADOF_PSHARED"},
  { /* PHASEOF_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I4, /*NULL*/"UPCR_PHASEOF_SHARED", "PHASEOF_S", "UPCR_PHASEOF_SHARED"},
  { /* PHASEOF_P */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I4, /*NULL*/"UPCR_PHASEOF_PSHARED", "PHASEOF_P", "UPCR_PHASEOF_PSHARED"},
  { /* ADDROF_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I4, /*NULL*/"UPCR_ADDRFIELD_SHARED", "ADDROF_S", "UPCR_ADDRFIELD_SHARED"},
  { /* ADDROF_P */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I4, /*NULL*/"UPCR_ADDRFIELD_PSHARED", "ADDROF_P", "UPCR_ADDRFIELD_PSHARED"},
  { /* G_LOCK_ALLOC */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_M, /*NULL*/"UPCR_GLOBAL_LOCK_ALLOC", "G_LOCK_ALLOC", "UPCR_GLOBAL_LOCK_ALLOC"},
  { /* A_LOCK_ALLOC */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_M, /*NULL*/"UPCR_ALL_LOCK_ALLOC", "A_LOCK_ALLOC", "UPCR_ALL_LOCK_ALLOC"},
  { /* LOCK_FREE */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_LOCK_FREE", "LOCK_FREE", "UPCR_LOCK_FREE"},
  { /* LOCK */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_LOCK", "LOCK", "UPCR_LOCK"},
  { /* LOCK_ATTEMPT */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I4, /*NULL*/"UPCR_LOCK_ATTEMPT", "LOCK_ATTEMPT", "UPCR_LOCK_ATTEMPT"},
  { /* LOCK_UNLOCK */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_UNLOCK", "LOCK_UNLOCK", "UPCR_UNLOCK"},
  { /* MEMCPY */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_MEMCPY", "UPC_MEMCPY", "UPCR_MEMCPY"},
  { /* MEMGET */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_MEMGET", "UPC_MEMGET", "UPCR_MEMGET"},
  { /* MEMPUT */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_MEMPUT", "UPC_MEMPUT", "UPCR_MEMPUT"},
  { /* MEMSET */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_MEMSET", "UPC_MEMSET", "UPCR_MEMSET"},
  { /* S_TO_L -- RTYPE*/
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_PV, /*NULL*/"UPCR_SHARED_TO_LOCAL", "S_TO_L", "UPCR_SHARED_TO_LOCAL"},
  { /* P_TO_L -- RTYPE*/
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_PV, /*NULL*/"UPCR_PSHARED_TO_LOCAL", "P_TO_L", "UPCR_PSHARED_TO_LOCAL"},
  { /* S_RESET */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_M, /*NULL*/"UPCR_SHARED_RESETPHASE", "S_RESET", "UPCR_SHARED_RESETPHASE"},
  { /* S_RESET_REF */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_shared_resetphase_ref", "S_RESET_REF", "upcr_shared_resetphase_ref"},
  { /* ISNIULL_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_ISNULL_SHARED", "ISNULL_S", "UPCR_ISNULL_SHARED"},
  { /* ISNULL_P */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_ISNULL_PSHARED", "ISNULL_P", "UPCR_ISNULL_PSHARED"},
  { /* ADD_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_M, /*NULL*/"UPCR_ADD_SHARED", "ADD_S", "UPCR_ADD_SHARED"},
  { /* INC_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_inc_shared", "INC_S", "upcr_inc_shared"},
  { /* ADD_P1 */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_M, /*NULL*/"UPCR_ADD_PSHARED1", "ADD_P1", "UPCR_ADD_PSHARED1"},
  { /* INC_P1 */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_inc_pshared1", "INC_P1", "upcr_inc_pshared1"},
  { /* EQ_S_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_ISEQUAL_SHARED_SHARED", "EQ_S_S", "UPCR_ISEQUAL_SHARED_SHARED"},
  { /* EQ_S_P */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_ISEQUAL_SHARED_PSHARED", "EQ_S_P", "UPCR_ISEQUAL_SHARED_PSHARED"},
  { /* EQ_P_P */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_ISEQUAL_PSHARED_PSHARED", "EQ_P_P", "UPCR_ISEQUAL_PSHARED_PSHARED"},
  { /* SUB_S --RTYPE */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I8, /*NULL*/"UPCR_SUB_SHARED", "UPC_SUB_S", "UPCR_SUB_SHARED"},
  { /* SUB_P1 --RTYPE */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I8, /*NULL*/"UPCR_SUB_PSHARED1", "UPC_SUB_P1", "UPCR_SUB_PSHARED1"},
  { /* AFF_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"upcr_hasMyAffinity_shared", "AFF_S", "upcr_hasMyAffinity_shared"},
  { /* AFF_P */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"upcr_hasMyAffinity_pshared", "AFF_P", "upcr_hasMyAffinity_pshared"},
  { /* PUT_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_PUT_SHARED", "PUT_S", "UPCR_PUT_SHARED"},
  { /* PUT_P */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_PUT_PSHARED", "PUT_P", "UPCR_PUT_PSHARED"},
  { /* GET_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_GET_SHARED", "GET_S", "UPCR_GET_SHARED"},
  { /* GET_P */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_GET_PSHARED", "GET_P", "UPCR_GET_PSHARED"},
  { /* PUT_NB_S --RTYPE*/
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_PUT_NB_SHARED", "PUT_NB_S", "UPCR_PUT_NB_SHARED"},
  { /* GET_NB_S --RTYPE*/
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_GET_NB_SHARED", "GET_NB_S", "UPCR_GET_NB_SHARED"},
  { /* PUT_NB_P --RTYPE*/
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_PUT_NB_PSHARED", "PUT_NB_P", "UPCR_PUT_NB_PSHARED"},
  { /* GET_NB_P --RTYPE*/
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_GET_NB_PSHARED", "GET_NB_P", "UPCR_GET_NB_PSHARED"},
  { /* WAIT_SYN */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_WAIT_SYNCNB", "WAIT_SYN", "UPCR_WAIT_SYNCNB"},
  { /* TRY_SYN */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_TRY_SYNCNB", "TRY_SYN", "UPCR_TRY_SYNCNB"},
  { /* PUT_NBI_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_put_nbi_shared", "PUT_NBI_S", "upcr_put_nbi_shared"},
  { /* GET_NBI_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_get_nbi_shared", "GET_NBI_S", "upcr_get_nbi_shared"},
  { /* PUT_NBI_P */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_put_nbi_pshared", "PUT_NBI_P", "upcr_put_nbi_pshared"},
  { /* GET_NBI_P */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_get_nbi_pshared", "GET_NBI_P", "upcr_get_nbi_pshared"},
  { /* WAIT_SYN_GET */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_wait_syncnbi_gets", "WAIT_SYN_GET", "upcr_wait_syncnbi_gets"},
  { /* WAIT_SYN_PUT */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_wait_syncnbi_puts", "WAIT_SYN_PUT", "upcr_wait_syncnbi_puts"},
  { /* WAIT_SYN_ALL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_wait_syncnbi_all", "WAIT_SYN_ALL", "upcr_wait_syncnbi_all"},
  { /* TRY_SYN_GET */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"upcr_try_syncnbi_gets", "TRY_SYN_GET", "upcr_try_syncnbi_gets"},
  { /* TRY_SYN_PUT */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"upcr_try_syncnbi_puts", "TRY_SYN_PUT", "upcr_try_syncnbi_puts"},
  { /* TRY_SYN_ALL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"upcr_try_syncnbi_all", "TRY_SYN_ALL", "upcr_try_syncnbi_all"},
  { /* BEGIN_REGION */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_begin_nbi_accessregion", "BEGIN_REGION", "upcr_begin_nbi_accessregion"},
  { /* END_REGION --RTYPE*/
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"upcr_end_nbi_accessregion", "END_REGION", "upcr_end_nbi_accessregion"},
  { /* PUT_S_VAL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_PUT_SHARED_VAL", "PUT_S_VAL", "UPCR_PUT_SHARED_VAL"},
  { /* PUT_NB_S_VAL --RTYPE*/
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_PUT_NB_SHARED_VAL", "PUT_NB_S_VAL", "UPCR_PUT_NB_SHARED_VAL"},
  { /* PUT_NBI_S_VAL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_put_nbi_shared_val", "PUT_NBI_S_VAL", "upcr_put_nbi_shared_val"},
  { /* PUT_P_VAL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_PUT_PSHARED_VAL", "PUT_P_VAL", "UPCR_PUT_PSHARED_VAL"},
  { /* PUT_NB_P_VAL --RTYPE */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_PUT_NB_PSHARED_VAL", "PUT_NB_P_VAL", "UPCR_PUT_NB_PSHARED_VAL"},
  { /* PUT_NBI_P_VAL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_put_nbi_pshared_val", "PUT_NBI_P_VAL", "upcr_put_nbi_pshared_val"},
  { /* GET_S_VAL --RTYPE */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_GET_SHARED_VAL", "GET_S_VAL", "UPCR_GET_SHARED_VAL"},
  { /* GET_P_VAL --RTYPE */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_GET_PSHARED_VAL", "GET_P_VAL", "UPCR_GET_PSHARED_VAL"},
  { /* GET_NB_S_VAL --RTYPE */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_GET_NB_SHARED_VAL", "GET_NB_S_VAL", "UPCR_GET_NB_SHARED_VAL"},
  { /* GET_NB_P_VAL --RTYPE */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    sizeof(int) == 4 ? IRETURN_I4 : IRETURN_I8, /*NULL*/"UPCR_GET_NB_PSHARED_VAL", "GET_NB_P_VAL", "UPCR_GET_NB_PSHARED_VAL"},
  { /* PUT_S_FVAL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_PUT_SHARED_FLOATVAL", "PUT_S_FVAL", "UPCR_PUT_SHARED_FLOATVAL"},
  { /* PUT_S_DVAL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_PUT_SHARED_DOUBLEVAL", "PUT_S_DVAL", "UPCR_PUT_SHARED_DOUBLEVAL"},
  { /* GET_S_FVAL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_F4, /*NULL*/"UPCR_GET_SHARED_FLOATVAL", "GET_S_FVAL", "UPCR_GET_SHARED_FLOATVAL"},
  { /* GET_S_DVAL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_F8, /*NULL*/"UPCR_GET_SHARED_DOUBLEVAL", "GET_S_DVAL", "UPCR_GET_SHARED_DOUBLEVAL"},
  { /* PUT_P_FVAL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_PUT_PSHARED_FLOATVAL", "PUT_P_FVAL", "UPCR_PUT_PSHARED_FLOATVAL"},
  { /* PUT_P_DVAL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_PUT_PSHARED_DOUBLEVAL", "PUT_P_DVAL", "UPCR_PUT_PSHARED_DOUBLEVAL"},
  { /* GET_P_FVAL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_F4, /*NULL*/"UPCR_GET_PSHARED_FLOATVAL", "GET_P_FVAL", "UPCR_GET_PSHARED_FLOATVAL"},
  { /* GET_P_DVAL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_F8, /*NULL*/"UPCR_GET_PSHARED_DOUBLEVAL", "GET_S_DVAL", "UPCR_GET_PSHARED_DOUBLEVAL"},
  { /* WAIT_SYN_VAL */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_WAIT_SYNCNB_VALGET", "WAIT_SYN_VAL", "UPCR_WAIT_SYNCNH_VALGET"},
  { /* TLD_ADDR */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_TLD_ADDR", "TLD_ADDR", "UPCR_TLD_ADDR"},
  { /* ADD_PI */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_M, /*NULL*/"UPCR_ADD_PSHAREDI", "ADD_PI", "UPCR_ADD_PSHAREDI"},
  { /* INC_PI */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_inc_psharedI", "INC_PI", "upcr_inc_psharedI"},
  { /* UPCFENCE */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"upcr_poll", "UPCFENCE", "upcr_poll"},
  { /* S_TO_P */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I8, /*NULL*/"UPCR_SHARED_TO_PSHARED", "S_TO_P", "UPCR_SHARED_TO_PSHARED"},
  { /* P_TO_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I8, /*NULL*/"UPCR_PSHARED_TO_SHARED", "P_TO_S", "UPCR_PSHARED_TO_SHARED"},
  { /* SETNULL_S */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_SETNULL_SHARED", "SETNULL_S", "UPCR_SETNULL_SHARED"},
  { /* SETNULL_P */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_SETNULL_PSHARED", "SETNULL_P", "UPCR_SETNULL_PSHARED"},
 { /* SETNULL_S_R */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_SETNULL_RSHARED", "SETNULL_S_R", "UPCR_SETNULL_RSHARED"},
  { /* SETNULL_P_R */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_V, /*NULL*/"UPCR_SETNULL_RPSHARED", "SETNULL_P_R", "UPCR_SETNULL_RPSHARED"},
  { /* SUB_PI */
    BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
    IRETURN_I8, /*NULL*/"UPCR_SUB_PSHAREDI", "UPC_SUB_PI", "UPCR_SUB_PSHAREDI"},
};

